'---------------------------------------------------------------------------
'              RC model finder (pro hledani modelu...) - v.1.0 
'                (c) 2004, Petr Bittnar, www.qsl.net/ok1mpe
'---------------------------------------------------------------------------
'
'       Vcc -|  U  |- Vss
'           -|     |- mode (via jumper)
'           -|     |- signal (servo pulses 1-2ms)
'     piezo -|     |- 
'
' mode=1 (jumper open):   zapnuti uzivatelsky + ztrata signalu
' mode=0 (jumper close):  pouze ztrata signalu

device 12c508
config WDT_OFF, MCLRE_OFF, CP_OFF, INTRC_OSC
xtal = 4
set_osccal	 							' nastaveni kalibrace oscilatoru
	
dim delay as byte						' deklarace promennych
dim fail as byte
symbol mode = gpio.0 					' volba rezimu
symbol signal = gpio.1					' signal (impulsy z prijimace)
symbol piezo = gpio.3					' akusticky vystup pro piezo

	option_reg.6 = 0					' povoleni pull-up
	option_reg.5 = 0					' pin 5 jako GP2
	trisio = %00000111					' nastaveni portu (vstupy / vystupy)
	fail = 0

main:
    delayms 10 							' pauza mezi merenim 
    delay = pulsin signal,high			' zmereni delky impulsu (nasobky 10us)

	if delay = 0 then					' pokud se nepodari zmerit delku (> 0.6s)
	   if fail < 30 then				' a vypadek signalu neprekrocil cca 20s
	   	  fail = fail + 1				' pripocti dalsi vypadek
	   else
	      sound piezo,[125,10]			' jinak pipni (strida cca 1:1)
       endif
	   goto main 		   				' opakuj mereni
	endif

	if delay <= 150 then				' pokud impuls < 1.5ms
	   if mode = 1 then sound piezo,[125,10] ' a je zap. rezim zapnuti, tak pipni 
	endif 
	fail = 0   	   			  			' prisel impuls vynuj pocitadlo vypadku

	Goto main 		 	  				' opakuj dokola
